'
' ***** Moveclient.vbs *****

	' OVERVIEW
		'This script will:
		'1. Log into the CS
		'2. List all computers in the specified client group defined by variable "clientGroupToSearch"
		'3. Perform an action on the client based on what the admin chooses.
		'	Actions can be selected by setting the variables below to "true" or "false" (case doesn't matter)
		'4. Move the computer into the laptops client group (or a group name of your choice defined by variable "moveToClientGroup")
		'5. Remove the computer from the waiting room client group
		'6. Send the admin an email

		'Assumptions:
		'If the client computer has more than 1 simpana user as the owner the script will take the last one unless you make provisions otherwise.

	'INSTRUCTIONS:
		'Fill the variable below according to your environment.  All variables need to be within the double quotes. 
		csName = ""
		loginuser = ""
		userpassword = ""
		clientGroupToSearch = "Waitingroom"
		moveToClientGroup = "Laptops"
		strUserGroup = ""
		REM 'variables for email.  users should be specified as fullyqualified as required by your stmp server.  
		REM 'multiple users can be specified in same sendto section if they are seperated by a semicolon and no spaces (i.e. "user1@company.com;user2@company.com")
		SMTPserver = ""
		sendto = ""
		sendcc =  ""
		sendbcc = ""
		sendfrom = ""

	'Set these variables to true or false depending on what actions you want to do the client computer before moving it into the active group
		bolGetOwner = true
		bolSetUserGroup = true
		bolSetEncryption = true
		bolSetDedupe = true
		bolSetContentindexing = true
		bolSetSRM = true
		bolSetDescription = true
		bolMoveToGroup = true
		bolSendEmail = true

' ***** SOME GLOBALS *****
Dim wshell: Set wshell = CreateObject("WScript.Shell")
Dim objFSO: Set objFSO = CreateObject("Scripting.FileSystemObject")
Dim arrayOwners ()
Dim arrayTemp () 'used to get xml attributes when only one is expected and will be immediatley copied into another variable before reusing the array
Const FORREADING = 1

homedir = objFSO.GetParentFolderName(wscript.ScriptFullName)
wscript.echo date & " " & time 
wscript.echo date & " " & time & " MOVECLIENT START"
 
'test if qlogin is needed.  if qlist command succeeds, we are still logged in, no need to login again
'since this script is designed to be run on schedule every few minutes, there is not need to login/logut.  only login if the session was timed out for some reason (script not run for a while)
strCMD = "cmd /c qlist client > qlist_test.txt" 
rc = wshell.run (strCMD, 0, TRUE)
if rc > 0 then
	'qlist command failed need to login again (session timed out)
	wscript.echo date & " " & time & " qlist returned: [" & rc & "] (need to try login again)"
	strCMD = "qlogin -u """ & loginuser & """  -ps """ & userpassword & """  -cs """ & csName & """ "
	wscript.echo date & " " & time & " " & strCMD
	rc = wshell.run (strCMD, 0, TRUE)
	wscript.echo date & " " & time & " qlogin returns: [" & rc & "]"
	if rc > 0 then
		wscript.echo date & " " & time & " ERROR: FAILED to log into CS ABORTING!"
		wscript.quit -1
	end if
end if

'get a list of computer in the waitingroom client group
strCMD = "cmd /c qlist client -cg """ & clientGroupToSearch& """ > clients.txt" 
rc = wshell.run (strCMD, 0, TRUE)
Set oFile = objFSO.GetFile( homedir & "\clients.txt")
if  oFile.Size = 0 then strToDo = " Nothing To Do!"
wscript.echo date & " " & time & " qlist returns: [" & rc & "] and filesize: [" &  oFile.Size  & "]" & strToDo
Set oFile = nothing

if rc = 0 then
	Set ClientListFile = objFSO.OpenTextFile( homedir & "\clients.txt", FORREADING, False )
	'loop through all the computers found in the client group to search (typically called waitingroom)
	Do While ClientListFile.AtEndOfStream <> True
		strCurrentComputer = trim(ClientListFile.ReadLine)
		'throw away (dont proccess) empty lines or the header lines
		if (instr( " name, ----," , lcase(strCurrentComputer) & ",") = 0) and (len(strCurrentComputer) > 0)  then

			 wscript.echo date & " " & time & " Processing client: [" & strCurrentComputer & "]"

			'get the computer owner,  full name and email values.  they can be used later on if desired
			if bolGetOwner then
				getClientProperties strCurrentComputer
				strCMD = "cmd /c qoperation execute -af ""getClientProperties.xml"" > ""getClientProperties_out.xml"""
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"				
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  get computer owner returned: [" & rc & "]"
				' 'use getElements to find the element in question (in this case clientOwners)
				numOwners = 0
				numOwners = getElements ("getClientProperties_out.xml", "clientOwners", arrayOwners)
				wscript.echo date & " " & time & " Number of owners for computer: [" & strCurrentComputer & "] is: [" & numOwners & "]"
				'if getElements finds a owner, numOwners will be > 0 and arrayOwners will contain them
				'there will usually be one or more domain account owners and 1 simpana owner
				if numOwners > 0 then
					for i = 0 to numOwners -1
						'do something here to pick a specific owner. there can be multiple owners and they can be either domain or simpana accounts
						strClientOwner = arrayOwners(i)
						wscript.echo date & " " & time & " Owner [" & i & "] is [" & strClientOwner & "]"
					next
					'get the owners full name and email property
						getUserProperties strClientOwner
						strCMD = "cmd /c qoperation execute -af ""getUserProperties.xml"" > ""getUserProperties_out.xml"""
						wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"						
						rc = wshell.run (strCMD, 0, TRUE)
						rc = getAttribute ("getUserProperties_out.xml", "users", "email", arrayTemp)
						ownerEmail = arrayTemp(0)
						rc = getAttribute ("getUserProperties_out.xml", "users", "fullName", arrayTemp)
						ownerFullName = arrayTemp(0)
						wscript.echo date & " " & time & " Owner [" & strClientOwner  & "] fullname: [" & ownerFullName & "] email: [" & ownerEmail & "]"
				else
					wscript.echo date & " " & time & " Client [" & strCurrentComputer & "] has NO Owners assigned!"
					strClientOwner = "NO OWNER"
				end if
			end if

			'associate the client computer to a specific EXISTING simpana user group
			if bolSetUserGroup then
				associateClientToUserGroup strCurrentComputer, strUserGroup
				strCMD = "cmd /c qoperation execute -af ""associateClientToUserGroup.xml"" > ""associateClientToUserGroup_out.xml"" "
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				numErrors = getElements ("associateClientToUserGroup_out.xml", "errorCode", arrayTemp)
				rc = arrayTemp(0)	
				wscript.echo date & " " & time & " RESULT:  associate client to user group returned: [" & rc & "]"
			end if

			'set client level encryption on the computer
			if bolSetEncryption then
				strCMD = "qoperation setencryptionprops -c """ & strCurrentComputer & """  -encryptdata  y  -mediaaccess  password  -restoreaccess  regular"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  set client encryption returned: [" & rc & "]"
			end if

			'enable client side deduplication
			if bolSetDedupe then
				enableClientSideDedupe strCurrentComputer
				strCMD = "cmd /c qoperation execute -af ""enableClientSideDedupe.xml"" > ""enableClientSideDedupe_out.xml"""
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)				
				numErrors = getElements ("enableClientSideDedupe_out.xml", "errorCode", arrayTemp)
				rc = arrayTemp(0)	
				wscript.echo date & " " & time & " RESULT:  enable client side deduplication returned: [" & rc & "]"
			end if

			'enable content indexing
			if bolSetContentindexing then
				setContentIndexing strCurrentComputer
				strCMD = "cmd /c qoperation execute -af ""setContentIndexing.xml"" -clients/client/cliententity/clientName """ &  strCurrentComputer & """ -cs """ & csName & """"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  enable content indexing returned: [" & rc & "]"
			end if

			'enable the SRM feature
			if bolSetSRM then
				setSRMFeature strCurrentComputer
				strCMD = "cmd /c qoperation execute -af ""setSRMFeature.xml"" -clientName """ &  strCurrentComputer & """ -cs """ & csName & """"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  enable the SRM feature returned: [" & rc & "]"
			end if

			'change the client computer description
			if bolSetDescription then
				strClientDescription = ""
				strCMD = "qoperation execscript -sn SetClientDescription.sql -si """ & strCurrentComputer & """ -si """ & strClientDescription & """"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  set client description returned: [" & rc & "]"
			end if

			'move the client computer from the "clientGroupToSearch" and into the "moveToClientGroup" client group
			if bolMoveToGroup then
				strCMD = "qoperation execscript -sn SetClientGroup.sql -si """ & strCurrentComputer & """ -si """ & moveToClientGroup & """"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  move computer to the " & moveToClientGroup & " returned: [" & rc & "]"

				strCMD = "qoperation execscript -sn SetClientGroup.sql -si """ & strCurrentComputer & """ -si """ & clientGroupToSearch & """ -si REM"
				wscript.echo date & " " & time & " COMMAND: [" & strCMD & "]"
				rc = wshell.run (strCMD, 0, TRUE)
				wscript.echo date & " " & time & " RESULT:  remove computer from " & clientGroupToSearch & "group returned: [" & rc & "]"
			end if

			'email the admin and let them know what happened
			if bolSendEmail then
				strBody = "Computer: [<b>" & strCurrentComputer & "</b>] was moved from the [<b>" & clientGroupToSearch & "</b>] group to: [<b>" & moveToClientGroup & "</b>] client group<br>"
				strBody = strBody & "The computer belongs to user: [<b>" & strClientOwner & "</b>]"
				wscript.echo date & " " & time & " EMAIL BODY: " & strBody
				sendMail sendto, sendcc, sendbcc, sendfrom, "MOVECLIENT: Computer has been move from the [" & clientGroupToSearch & "] client group to the [" & moveToClientGroup & "] client group", strBody
			end if

		end if
	Loop
	ClientListFile.close
else
	wscript.echo date & " " & time & " qlist returns: [" & rc & "] either error or no clients found in the specified group"
end if

'if scheduling	repeatedly don't log out. Allow last session to remain open. Prevents constant login/logout.
'qlogout

wscript.echo date & " " & time & " MOVECLIENT END"
wscript.quit 0

'helper subs and functions
sub qlogout ()
	strCMD = "qlogout"
	rc = wshell.run (strCMD, 0, TRUE)
	wscript.echo date & " " & time & " qlogout returns: [" & rc & "]"
end sub

sub getUserProperties (strUserName )
	strGetUser = "<App_GetUserPropertiesRequest level=""30"">"& VBCRLF &_
		"<user _type_=""USER_ENTITY"" userName=""" & strUserName & """/>"& VBCRLF &_
	"</App_GetUserPropertiesRequest>"
	saveXML strGetUser, "getUserProperties.xml"
end sub

sub getClientProperties (strClient )
	strGetClient = "<App_GetClientPropertiesReq>"& VBCRLF &_
		"<association>"& VBCRLF &_
			"<entity clientName=""" & strClient & """/>"& VBCRLF &_
		"</association>"& VBCRLF &_
	"</App_GetClientPropertiesReq>"	
	saveXML strGetClient, "getClientProperties.xml"
end sub

sub associateClientToUserGroup (strClient, strUserGroup )
	strAssociateClientToUserGroup = "<App_SetClientProperties>"& VBCRLF &_
		"<association>"& VBCRLF &_
		"<entity>"& VBCRLF &_
			"<clientName>" & strClient & "</clientName>"& VBCRLF &_
		"</entity>"& VBCRLF &_
		"</association>"& VBCRLF &_
		"<clientInfo>"& VBCRLF &_
			"<clientProps>"& VBCRLF &_
				"<clientSecurity>"& VBCRLF &_
					"<associatedUserGroups>"& VBCRLF &_
						"<userGroupName>" & strUserGroup & "</userGroupName>"& VBCRLF &_
					"</associatedUserGroups>"& VBCRLF &_
					"<associatedUserGroupsOperationType>ADD</associatedUserGroupsOperationType>"& VBCRLF &_
				"</clientSecurity>"& VBCRLF &_
			"</clientProps>"& VBCRLF &_
		"</clientInfo>"& VBCRLF &_
	"</App_SetClientProperties>"
	saveXML strAssociateClientToUserGroup, "associateClientToUserGroup.xml"	
end sub

sub setSRMFeature (strClient )
	strSRMFeature = "<App_SetSubclientProperties>"& VBCRLF &_
		"<association>"& VBCRLF &_
			"<entity>"& VBCRLF &_
				"<clientName>" & strClient & "</clientName>"& VBCRLF &_
			"</entity>"& VBCRLF &_
		"</association>"& VBCRLF &_
		"<subclientInfo>"& VBCRLF &_
			"<srmProperties>"& VBCRLF &_
				"<enableSRMFeatureAtAgent>true</enableSRMFeatureAtAgent>"& VBCRLF &_
				"<enableSRMDC>true</enableSRMDC>"& VBCRLF &_
				"<enableDiscovery>true</enableDiscovery>"& VBCRLF &_
				"<enableDiscoveryAndAnalysis>false</enableDiscoveryAndAnalysis>"& VBCRLF &_
				"<enableFileLevelAnalytics>false</enableFileLevelAnalytics>"& VBCRLF &_
			"</srmProperties>"& VBCRLF &_
		"</subclientInfo>"& VBCRLF &_
	"</App_SetSubclientProperties>"
	saveXML strSRMFeature, "setSRMFeature.xml"
end sub

sub setContentIndexing (strClient )
	strSetContentIndexing = "<App_SetClientsProperties>"& VBCRLF &_
		"<App_ClientsList>"& VBCRLF &_
			"<clients>"& VBCRLF &_
				"<clientProps EnableContentIndexing=""true"">"& VBCRLF &_
				"</clientProps>"& VBCRLF &_
				"<client>"& VBCRLF &_
					"<clientEntity clientName=""" & strClient & """/>"& VBCRLF &_
				"</client>"& VBCRLF &_
			"</clients>"& VBCRLF &_
		"</App_ClientsList>"& VBCRLF &_
	"</App_SetClientsProperties>"
	saveXML strSetContentIndexing, "setContentIndexing.xml"
end sub

sub enableClientSideDedupe (strClient )
	strEnableClientSideDedupe = "<App_SetClientProperties>"& VBCRLF &_
		"<association>"& VBCRLF &_
			"<entity>"& VBCRLF &_
				"<clientName>" & strClient & "</clientName>"& VBCRLF &_
			"</entity>"& VBCRLF &_
		"</association>"& VBCRLF &_
		"<clientInfo>"& VBCRLF &_
			"<clientProps>"& VBCRLF &_
				"<deDuplicationProperties>"& VBCRLF &_
					"<performClientSideDeduplication>true</performClientSideDeduplication>"& VBCRLF &_
					"<enableClientSideDiskCache>false</enableClientSideDiskCache>"& VBCRLF &_
					"<maxCacheDb>1079</maxCacheDb>"& VBCRLF &_
					"<enableVariableContentAlignment>false</enableVariableContentAlignment>"& VBCRLF &_
				"</deDuplicationProperties>"& VBCRLF &_
			"</clientProps>"& VBCRLF &_
		"</clientInfo>"& VBCRLF &_
	"</App_SetClientProperties>"
	saveXML strEnableClientSideDedupe, "enableClientSideDedupe.xml"
end sub

sub saveXML (strXML, strFileName)
	'saves the given string as an xml file
	Set doc = CreateObject("Microsoft.XMLDOM")
	doc.async = false
	doc.ValidateonParse = False
	doc.resolveExternals = False
	doc.LoadXml (strXML)
	doc.save strFileName
	set doc = Nothing	
end sub

function getAttribute (strFileName, strNode, strAttribute, arrayGetAttribute)
	'reads xml file, searches for the node passed in and populates the array with the value of the ATTRIBUTE in that node
	'returns the number of values in the array
	attributeCount = 0:	dim i
	Erase arrayGetAttribute: Redim arrayGetAttribute(1)
	Set doc = createobject("Microsoft.XMLDOM")
	doc.async = "false"
	doc.load (strFileName)
	Set Root = doc.documentElement	
	Set response = doc.getElementsByTagName(strNode)
	if response.length > 0 then
		Redim Preserve arrayGetAttribute(response.length)	
		for i = 0 to response.length -1
			if len(response.item(i).getAttribute(strAttribute)) > 0 then 
				arrayGetAttribute(attributeCount) = response.item(i).getAttribute(strAttribute)
				attributeCount = attributeCount + 1
			end if
		next
	end if
	set doc = Nothing
	getAttribute = attributeCount
end function

function getElements (strFileName, strNode, array_getElement)
	'reads xml file, searches for the node passed in and populates the array with the values
	'returns the number of values in the array
	elementCount = 0: dim i
	Erase array_getElement: Redim array_getElement(1)
	Set doc = createobject("Microsoft.XMLDOM")
	doc.async = "false"
	doc.load (strFileName)
	Set Root = doc.documentElement	
	Set response = doc.getElementsByTagName(strNode)
	if response.length > 0 then 
		Redim Preserve array_getElement(response.length)
		for i = 0 to response.length - 1
			array_getElement(i) =  response.item(i).text
			elementCount = elementCount + 1
		next		
	end if
	set doc = Nothing
	getElements = elementCount	
end function

sub sendMail (strTo, strCC, strBCC, strFrom, strSubject, strBody)
	On error resume next
	Dim iMsg, iConf, Flds
	Const CdoReferenceTypeName = 1
	Const ForReading = 1
	Const cdoSendUsingPort = 2
	set iMsg = CreateObject("CDO.Message")
	set iConf = CreateObject("CDO.Configuration")
	Set Flds = iConf.Fields
	' Set the CDOSYS configuration fields to use port 25 on the SMTP server.
	With Flds
		.Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = cdoSendUsingPort
		.Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") = SMTPServer
		.Item("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 10  
		.Update
	End With
	' Apply the settings to the message.
	With iMsg
		Set .Configuration = iConf
		.To = strTo
		.Cc = strCC
		.Bcc = strBCC
		.From = strFrom
		.Subject = strSubject
		.HTMLBody = "<html>" & strBody& "</html>"
		.MimeFormatted = True 
		.send
	End With
	' Clean up variables.
	Set iMsg = Nothing
	Set iConf = Nothing
	Set Flds = Nothing
	On error goto 0
end sub